Subject: Re: very minor 405GP and 405GPr PCI difference

From: David Gibson <[email-masked]>
Date: Mon, 14 Oct 2002 11:20:47 +1000

On Fri, Oct 11, 2002 at 12:37:20PM -0700, Andrew May wrote:
>
> Sorry about the late reply but I wanted to check the 2.5 tree and I haven't
> been looking at it before.
>
> On Wed, Oct 09, 2002 at 11:58:28AM +1000, David Gibson wrote:
> >
> > On Mon, Oct 07, 2002 at 10:21:36PM -0700, Andrew May wrote:
> > >
> > > A full featured bootloader like PPCboot will need to setup the PCI bus
> > > to work with PCI devices, so it is not like it is always an extra burden
> > > on the bootloader or useless work.
> >
> > That's all very well if you've got PPCboot, but lots of boards have
> > firmware which is, lets face it, shite.  The kernel has to be able to
> > deal with this case.  And since it has to deal with it for the case of
> > crappy firmware, is there any point turning it off for the case of
> > decent firmware?
>
> Yes there is a point. I am working on a new custum PCI device and the
> hardware guy gives me silly requests to try differnt PCI bus settings.
> And I would much rather make the changes in my small quick PPCBoot build
> rather than a full kernel build.

Well, for a fair few of the settings - the mapping addresses at least,
the kernel has to know what the settings are to workk, even if PPCBoot
has already set things up.

Incidentally the Makefiles in 2.5 are greatly improved, so kernel
builds with small changes are often a lot less painful than they used
to be.

> > > So I just want you to keep in mind the PCI bus fixup can be a config
> > > option that can be built out if desired. It really shouldn't be tied
> > > to the board itself, since it is also common to load in PPCboot into
> > > Walnut boards.
> >
> > That's easy - in fact the patch I posted before allows this (it won't
> > do anything if CONFIG_BIOS_FIXUP is not defined).
>
> Well you patch is only part of the issue, it is the rest of
> arch/ppc/kernel/4xx/ppc405_pci.c that gets pulled in every build with PCI,
> that remapps everything in _find_bridges.

True, but it's an even smaller subset of platforms that could do
without that code.

--
David Gibson			| For every complex problem there is a
[email-masked]	| solution which is simple, neat and
				| wrong.
http://www.ozlabs.org/people/dgibson

** Sent via the linuxppc-embedded mail list. See http://lists.linuxppc.org/